Package org.apache.felix.gogo.command

# Class Util

java.lang.Object
org.apache.felix.gogo.command.Util

public class Util extends Object

## Constructor Summary

Constructors
Constructor
Description
`Util()`

## Method Summary

Modifier and Type
Method
Description
`static boolean`
`compareSubstring(List<String> pieces, String s)`
`static void`
`copy(InputStream is, File dir, String destName, String destDir, byte[] buffer)`
`static void`
`downloadSource(PrintStream out, PrintStream err, URL srcURL, File localDir, boolean extract)`
`static String`
`getBundleName(org.osgi.framework.Bundle bundle)`
`static <T> T`
`getService(org.osgi.framework.BundleContext bc, Class<T> clazz, List<org.osgi.framework.ServiceReference> refs)`
`static String`
`getUnderlineString(int len)`
`static String`
`getValueString(Object obj)`
`static InputStream`
`openURL(URL url)`
`static InputStream`
`openURL(URLConnection conn)`
`static List<String>`
`parseSubstring(String value)`
`static void`
`setProxyAuth(URLConnection conn)`
`static void`
`ungetServices(org.osgi.framework.BundleContext bc, List<org.osgi.framework.ServiceReference> refs)`
`static void`
`unjar(JarInputStream jis, File dir)`
`static String`
`unparseSubstring(List<String> pieces)`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### Util

public Util()

## Method Details

### getBundleName

public static String getBundleName(org.osgi.framework.Bundle bundle)

### getUnderlineString

public static String getUnderlineString(int len)

### getValueString

public static String getValueString(Object obj)

### getService

public static <T> T getService(org.osgi.framework.BundleContext bc, Class<T> clazz, List<org.osgi.framework.ServiceReference> refs)

### ungetServices

public static void ungetServices(org.osgi.framework.BundleContext bc, List<org.osgi.framework.ServiceReference> refs)

### downloadSource

public static void downloadSource(PrintStream out, PrintStream err, URL srcURL, File localDir, boolean extract)

### unjar

public static void unjar(JarInputStream jis, File dir) throws IOException

Throws:
  `IOException`

### copy

public static void copy(InputStream is, File dir, String destName, String destDir, byte[] buffer) throws IOException

Throws:
  `IOException`

### setProxyAuth

public static void setProxyAuth(URLConnection conn) throws IOException

Throws:
  `IOException`

### openURL

public static InputStream openURL(URL url) throws IOException

Throws:
  `IOException`

### openURL

public static InputStream openURL(URLConnection conn) throws IOException

Throws:
  `IOException`

### parseSubstring

public static List<String> parseSubstring(String value)

### unparseSubstring

public static String unparseSubstring(List<String> pieces)

### compareSubstring

public static boolean compareSubstring(List<String> pieces, String s)